/* ANSI C namespace clean utility typedefs */

/* This file defines various typedefs needed by the system calls that support
   the C library.  Basically, they're just the POSIX versions with an '_'
   prepended.  This file lives in the `sys' directory so targets can provide
   their own if desired (or they can put target dependant conditionals here).
*/

#ifndef	_SYS__TYPES_H
#define _SYS__TYPES_H

typedef long _off_t;
__extension__ typedef long long _off64_t;

#if defined(__INT_MAX__) && __INT_MAX__ == 2147483647
typedef int _ssize_t;
#else
typedef long _ssize_t;
#endif

#define __need_wint_t
#include <stddef.h>

#ifndef _MBSTATE_T
#define _MBSTATE_T
/* Conversion state information.  */
typedef struct
{
  int __count;
  union
  {
    wint_t __wch;
    char __wchb[4];
  } __value;		/* Value so far.  */
} _mbstate_t;
#endif /* _MBSTATE_T */

#ifdef __CYGWIN__
# ifndef MBSTATE_T
#  define MBSTATE_T
typedef _mbstate_t mbstate_t;
# endif /* MBSTATE_T */
# define WEOF (0xffffffffu)
#endif /* __CYGWIN__ */

#endif	/* _SYS__TYPES_H */
